# NWidgetSpacer Class Reference
[Hierarchical widgets]

Spacer widget. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetSpacer:

## Public Member Functions
| NWidgetSpacer (int length, int height)
| Generic spacer widget.
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | FillNestedArray (NWidgetBase **array, uint length)
void | Draw (const Window *w)
| Draw the widgets of the tree.
void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.

## Detailed Description

Spacer widget.

Definition at line 412 of file widget_type.h.

## Constructor & Destructor Documentation

NWidgetSpacer::NWidgetSpacer | ( | int | length,
|  | int | height |
| ) |  |  |

Generic spacer widget.

Parameters:

  | length | Horizontal size of the spacer widget.
  | height | Vertical size of the spacer widget.

Definition at line 1393 of file widget.cpp.

References NWidgetResizeBase::SetMinimalSize(), and NWidgetResizeBase::SetResize().

## Member Function Documentation

void NWidgetSpacer::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array |
| ) |  |  | `[virtual]`

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters:

  | w | Window owning the widget.
  | init_array | Initialize the `w->nested_array`.

Note:
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1399 of file widget.cpp.

References NWidgetResizeBase::min_x, NWidgetResizeBase::min_y, NWidgetBase::smallest_x, and NWidgetBase::smallest_y.

void NWidgetSpacer::Draw | ( | const Window * | w | ) | `[virtual]`

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters:

  | w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1409 of file widget.cpp.

void NWidgetSpacer::SetDirty | ( | const Window * | w | ) | const`[virtual]`

Mark the widget as 'dirty' (in need of repaint).

Parameters:

  | w | Window owning the widget.

Reimplemented from NWidgetBase.

Definition at line 1414 of file widget.cpp.

NWidgetCore * NWidgetSpacer::GetWidgetFromPos | ( | int | x,
|  | int | y |
| ) |  |  | `[virtual]`

Retrieve a widget by its position.

Parameters:

  | x | Horizontal position relative to the left edge of the window.
  | y | Vertical position relative to the top edge of the window.

Returns:
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1419 of file widget.cpp.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp